package yourdomain.config
{
    import yourdomain.controllers.commands.*;
    import yourdomain.models.FoodOrderModel;
    import yourdomain.controllers.signals.*;
    import yourdomain.views.components.*;
    import yourdomain.views.mediators.*;
    import org.robotlegs.mvcs.SignalContext;

    public class SignalCafeContext extends SignalContext
    {
        override public function startup():void
        {
            trace("SignalCafeContext.startup()");

            injector.mapSingleton(FoodOrderModel);
            injector.mapSingleton(FoodOrderUpdated);
            injector.mapSingleton(FoodItemAddedToOrder);

            signalCommandMap.mapSignalClass(AddFoodItemToOrder, AddFoodItemToOrderCommand);
            signalCommandMap.mapSignalClass(FoodItemSelected, FoodItemSelectedCommand);
            signalCommandMap.mapSignalClass(RemoveAllOfSelectedItem, RemoveAllSelectedItemCommand);
            signalCommandMap.mapSignalClass(NoFoodItemSelected, NoFoodItemSelectedCommand);

            mediatorMap.mapView(FoodSelectionView, FoodSelectionViewMediator);
            mediatorMap.mapView(CurrentOrderView, CurrentOrderViewMediator);
            mediatorMap.mapView(FoodOrderSummaryView, FoodOrderSummaryViewMediator);
            mediatorMap.mapView(FoodItemRemovalView, FoodItemRemovalViewMediator);
        }
    }
}