package yourdomain.models
{
    import mx.collections.ArrayCollection;

    import yourdomain.models.enums.FoodType;
    import yourdomain.models.vo.FoodItem;
    import yourdomain.models.vo.FoodOrder;
    import yourdomain.controllers.signals.FoodItemAddedToOrder;
    import yourdomain.controllers.signals.FoodOrderUpdated;
    import yourdomain.controllers.signals.NoFoodItemSelected;
    import org.robotlegs.mvcs.Actor;

    public class FoodOrderModel extends Actor
    {
        [Inject]
        public var orderUpdated:FoodOrderUpdated;

        [Inject]
        public var itemAdded:FoodItemAddedToOrder;

        [Inject]
        public var noFoodItemSelected:NoFoodItemSelected;

        private var _foodOrder:FoodOrder;

        public function get foodOrder():FoodOrder
        {
            return _foodOrder;
        }

        private var _currentItemSelection:FoodItem;

        public function get currentItemSelection():FoodItem
        {
            return _currentItemSelection;
        }

        public function set currentItemSelection(value:FoodItem):void
        {
            _currentItemSelection = value;
        }

        public function FoodOrderModel()
        {
            _foodOrder = new FoodOrder();
        }

        public function addItemToOrder(type:FoodType):void
        {
            var item:FoodItem = getFoodItemByType(type);

            item.quantity++;
            foodOrder.addItem(item);

            itemAdded.dispatch(item);
            orderUpdated.dispatch(foodOrder);
        }

        protected function getFoodItemByType(type:FoodType):FoodItem
        {
            var item:FoodItem;

            for each (item in foodOrder.foodItems)
            {
                if (item.type == type)
                    return item;
            }
            item = new FoodItem(type);
            return item;
        }

        public function removeAllOf(item:FoodItem):void
        {
            foodOrder.removeItem(item);
            noFoodItemSelected.dispatch();
            orderUpdated.dispatch(foodOrder);
        }
    }
}
