package  yourdomain.views.mediators
{
	import yourdomain.models.vo.FoodItem;
	import yourdomain.models.vo.FoodOrder;
	import yourdomain.controllers.signals.FoodItemAddedToOrder;
	import yourdomain.controllers.signals.FoodItemSelected;
	import yourdomain.controllers.signals.FoodOrderUpdated;
	import yourdomain.controllers.signals.NoFoodItemSelected;
	import yourdomain.views.components.CurrentOrderView;
	import org.robotlegs.mvcs.Mediator;
	
	public class CurrentOrderViewMediator extends Mediator
	{
		[Inject]
		public var view:CurrentOrderView;
		
		[Inject]
		public var orderUpdated:FoodOrderUpdated;
		
		[Inject]
		public var foodItemSelected:FoodItemSelected;
		
		[Inject]
		public var noFoodItemSelected:NoFoodItemSelected;
		
		[Inject]
		public var foodItemAddedToOrder:FoodItemAddedToOrder;
		
		override public function onRegister():void
		{
			orderUpdated.add(updateOnOrderUpdated);
			foodItemAddedToOrder.add(updateOnItemAdded);
			view.foodItemSelected.add(updateOnItemSelected);	

		}
		
		protected function updateOnItemAdded(item:FoodItem):void
		{
			trace("CurrentOrderViewMediator.updateOnItemAdded(item)");			
			view.items.selectedItem = item;
			foodItemSelected.dispatch(item);
		}
		
		protected function updateOnItemSelected(item:FoodItem):void
		{
			trace("CurrentOrderViewMediator.updateOnItemSelected(item)");			
			if(item)
				foodItemSelected.dispatch(item);
			else
				noFoodItemSelected.dispatch();
		}
		
		protected function updateOnOrderUpdated(order:FoodOrder):void
		{
			trace("CurrentOrderViewMediator.updateOnOrderUpdated(order)");			
			if(!view.dataProvider)
				view.dataProvider = order.foodItems;
		}
	}
}