package yourdomain.views.mediators
{
	
	
	import org.robotlegs.mvcs.Mediator;
	
	import spark.components.mediaClasses.VolumeBar;
	
	import yourdomain.controllers.signals.FoodItemSelected;
	import yourdomain.controllers.signals.NoFoodItemSelected;
	import yourdomain.controllers.signals.RemoveAllOfSelectedItem;
	import yourdomain.models.vo.FoodItem;
	import yourdomain.views.components.FoodItemRemovalView;
	
	public class FoodItemRemovalViewMediator extends Mediator
	{
		[Inject]
		public var view:FoodItemRemovalView;
		
		[Inject]
		public var removeAllOfItem:RemoveAllOfSelectedItem;
		
		[Inject]
		public var itemSelected:FoodItemSelected;
		
		[Inject]
		public var noFoodItemSelected:NoFoodItemSelected;
		
		override public function onRegister():void
		{
			view.removeAllItemsClicked.add(handleRemoveAllItemsClicked);
			
			itemSelected.add(updateOnItemSelected);
			noFoodItemSelected.add(updateOnNoItemSelected);
		}
		
		protected function updateOnItemSelected(item:FoodItem):void
		{
			trace("FoodItemRemovalViewMediator.updateOnItemSelected(item)");			
			view.enabled = item is FoodItem;
		}
		
		protected function updateOnNoItemSelected():void
		{
			trace("FoodItemRemovalViewMediator.updateOnNoItemSelected()");			
			view.enabled = false;
		}
		
		protected function handleRemoveAllItemsClicked():void
		{
			trace("FoodItemRemovalViewMediator.handleRemoveAllItemsClicked()");			
			removeAllOfItem.dispatch();
		}
	}
}