package yourdomain.views.mediators
{
	
	import yourdomain.models.vo.FoodOrder;
	import org.robotlegs.mvcs.Mediator;
	
	import yourdomain.controllers.signals.FoodOrderUpdated;
	import yourdomain.views.components.FoodOrderSummaryView;
	
	public class FoodOrderSummaryViewMediator extends Mediator
	{
		[Inject]
		public var view:FoodOrderSummaryView;
		
		[Inject]
		public var orderUpdated:FoodOrderUpdated;
		
		override public function onRegister():void
		{
			trace("FoodOrderSummaryViewMediator.onRegister()");			
			orderUpdated.add(updateViewOnOrderUpdated);
		}
		
		protected function updateViewOnOrderUpdated(order:FoodOrder):void
		{
			trace("FoodOrderSummaryViewMediator.updateViewOnOrderUpdated(order)");			
			if(!view.order)
				view.order = order;
		}
	}
}