package yourdomain.views.mediators
{
	
	import org.robotlegs.mvcs.Mediator;
	
	import yourdomain.controllers.signals.AddFoodItemToOrder;
	import yourdomain.models.enums.FoodType;
	import yourdomain.views.components.FoodSelectionView;
	
	public class FoodSelectionViewMediator extends Mediator
	{
		[Inject]
		public var view: FoodSelectionView;
		
		[Inject]
		public var addItem:AddFoodItemToOrder;
		
		override public function onRegister():void
		{
			trace("FoodSelectionViewMediator.onRegister()");			
			view.itemTypeAdded.add(handleItemTypeAdded);
		}
		
		protected function handleItemTypeAdded(itemType:FoodType):void
		{
			trace("FoodSelectionViewMediator.handleItemTypeAdded(itemType)");			
			addItem.dispatch(itemType);
		}
	}
}